//
//  TEWindow.swift
//  CommandPallete
//
//  Created by narita on 2018/11/02.
//  Copyright © 2018 narita. All rights reserved.
//

import Cocoa

class TEWindow: NSWindow
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    @IBAction func selectTabbedWindow0(_ sender: Any?)
    {
        self.selectTabbed(window: 0)
    }
    
    @objc func canSelectTabbedWindow0() -> Bool
    {
        return self.canSelectTabbed(window:0)
    }
    
    @IBAction func selectTabbedWindow1(_ sender: Any?)
    {
        self.selectTabbed(window: 1)
    }
    
    @objc func canSelectTabbedWindow1() -> Bool
    {
        return self.canSelectTabbed(window:1)
    }
    
    @IBAction func selectTabbedWindow2(_ sender: Any?)
    {
        self.selectTabbed(window: 2)
    }
    
    @objc func canSelectTabbedWindow2() -> Bool
    {
        return self.canSelectTabbed(window:2)
    }
    
    @IBAction func selectTabbedWindow3(_ sender: Any?)
    {
        self.selectTabbed(window: 3)
    }
    
    @objc func canSelectTabbedWindow3() -> Bool
    {
        return self.canSelectTabbed(window:3)
    }
    
    @IBAction func selectTabbedWindow4(_ sender: Any?)
    {
        self.selectTabbed(window: 4)
    }
    
    @objc func canSelectTabbedWindow4() -> Bool
    {
        return self.canSelectTabbed(window:4)
    }
    
    @IBAction func selectTabbedWindow5(_ sender: Any?)
    {
        self.selectTabbed(window: 5)
    }
    
    @objc func canSelectTabbedWindow5() -> Bool
    {
        return self.canSelectTabbed(window:5)
    }
    
    @IBAction func selectTabbedWindow6(_ sender: Any?)
    {
        self.selectTabbed(window: 6)
    }
    
    @objc func canSelectTabbedWindow6() -> Bool
    {
        return self.canSelectTabbed(window:6)
    }
    
    @IBAction func selectTabbedWindow7(_ sender: Any?)
    {
        self.selectTabbed(window: 7)
    }
    
    @objc func canSelectTabbedWindow7() -> Bool
    {
        return self.canSelectTabbed(window:7)
    }
    
    @IBAction func selectTabbedWindow8(_ sender: Any?)
    {
        self.selectTabbed(window: 8)
    }
    
    @objc func canSelectTabbedWindow8() -> Bool
    {
        return self.canSelectTabbed(window:8)
    }
    
    @IBAction func selectTabbedWindow9(_ sender: Any?)
    {
        self.selectTabbed(window: 9)
    }
    
    @objc func canSelectTabbedWindow9() -> Bool
    {
        return self.canSelectTabbed(window:9)
    }
    
    // MARK: - event handling methods
    
    func selectTabbed(window tabNumber: NSInteger)
    {
        if let theTabs = self.tabbedWindows as Array<NSWindow>?
        {
            switch tabNumber
            {
            case 1...9:
                if theTabs.count > tabNumber - 1
                {
                    theTabs[tabNumber - 1].makeKeyAndOrderFront(self)
                }
                
            case 0:
                if theTabs.count > 9
                {
                    theTabs[9].makeKeyAndOrderFront(self)
                }
            default:
                return
            }
        }
    }
    
    func canSelectTabbed(window tabNumber: NSInteger) -> Bool
    {
        if let theTabs = self.tabbedWindows as Array<NSWindow>?
        {
            switch tabNumber
            {
            case 1...9:
                if theTabs.count > tabNumber - 1
                {
                    return true
                }
                
            case 0:
                if theTabs.count > 9
                {
                    return true
                }
            default:
                return false
            }
        }
        
        return false
    }
    
    override func performKeyEquivalent(with event: NSEvent) -> Bool
    {
        // 修飾キーでコマンドキーだけが押されているか否か
        if  (
                event.type == NSEvent.EventType.keyDown
            )
            &&
            (
                    ( event.modifierFlags.rawValue & NSEvent.ModifierFlags.command.rawValue)
                ==
                    NSEvent.ModifierFlags.command.rawValue
            )
        {
            if let string = event.characters
            {
                if (self.tabbedWindows as Array<NSWindow>?) != nil
                {
                    // 数字の1から9と0までのキーが押されているか
                    switch string
                    {
                        case "1":
                            if self.canSelectTabbedWindow1()
                            {
                                self.selectTabbedWindow1(nil)
                                return true
                            }
                        
                        case "2":
                            if self.canSelectTabbedWindow2()
                            {
                                self.selectTabbedWindow2(nil)
                                return true
                            }
                        
                        case "3":
                            if self.canSelectTabbedWindow3()
                            {
                                self.selectTabbedWindow3(nil)
                                return true
                            }
                        
                        case "4":
                            if self.canSelectTabbedWindow4()
                            {
                                self.selectTabbedWindow4(nil)
                                return true
                            }
                        
                        case "5":
                            if self.canSelectTabbedWindow5()
                            {
                                self.selectTabbedWindow5(nil)
                                return true
                            }
                        
                        case "6":
                            if self.canSelectTabbedWindow6()
                            {
                                self.selectTabbedWindow6(nil)
                                return true
                            }
                        
                        case "7":
                            if self.canSelectTabbedWindow7()
                            {
                                self.selectTabbedWindow7(nil)
                                return true
                            }
                        
                        case "8":
                            if self.canSelectTabbedWindow8()
                            {
                                self.selectTabbedWindow8(nil)
                                return true
                            }
                        
                        case "9":
                            if self.canSelectTabbedWindow9()
                            {
                                self.selectTabbedWindow9(nil)
                                return true
                            }
                        
                        case "0":
                            if self.canSelectTabbedWindow0()
                            {
                                self.selectTabbedWindow0(nil)
                                return true
                            }
                        
                        default:
                            return super.performKeyEquivalent(with: event)
                    }
                }
            }
        }
        // ここで、キーイベントのハックをしても良い....?
        return super.performKeyEquivalent(with: event)
    }
    
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    // MARK: - Utility methods
    
}
